/*
 * @(#)ShutdownHook.java
 * Date 2012-07-22
 * Version 1.0
 * Author Jim Horner
 * Copyright (c)2012
 */


package us.hornerscorners.mojo.glassfish;

import org.glassfish.embeddable.GlassFish;
import org.glassfish.embeddable.GlassFishException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


/**
 *
 * @author jim
 */
public class ShutdownHook extends Thread {

    /** Field description */
    private final String deployedWebApp;

    /** Field description */
    private final GlassFish glassfish;

    /** Field description */
    private boolean isShutdown;

    /** Field description */
    private final Logger logger = LoggerFactory.getLogger(getClass());

    /**
     * Constructs ...
     *
     *
     * @param gf
     */
    public ShutdownHook(GlassFish gf, String deployedWebApp) {

        super();
        this.glassfish = gf;
        this.deployedWebApp = deployedWebApp;
        this.isShutdown = false;
    }

    /**
     * Method description
     *
     */
    public synchronized void executeHook() {

        if (isShutdown == false) {

            stopWebApp();
            stopGlassfish();

            isShutdown = true;
        }
    }

    /**
     * Method description
     *
     */
    @Override
    public void run() {

        executeHook();
    }

    /**
     * Method description
     *
     */
    private void stopGlassfish() {

        try {

            logger.info("Stopping GlassFish.");

            this.glassfish.stop();
            this.glassfish.dispose();

        } catch (GlassFishException e) {

            logger.error("Unable to shutdown glassfish.", e);
        }
    }

    /**
     * Method description
     *
     */
    private void stopWebApp() {

        try {

            this.glassfish.getDeployer().undeploy(this.deployedWebApp);

        } catch (GlassFishException e) {

            logger.error("Unable to undeploy webapp.", e);
        }
    }
}
