/*
 * @(#)VersionControlFilter.java
 * Date 2012-07-22
 * Version 1.0
 * Author Jim Horner
 * Copyright (c)2012
 */


package us.hornerscorners.mojo.glassfish;

import java.io.File;
import java.io.FileFilter;

import org.apache.commons.io.filefilter.IOFileFilter;


/**
 *
 * @author jim
 */
public class VersionControlFilter implements IOFileFilter, FileFilter {

    /** Field description */
    private static final String[] IGNORES = { ".svn", ".cvs" };

    /**
     * Method description
     *
     *
     *
     * @return
     */
    @Override
    public boolean accept(File file) {

        boolean result = true;

        if (file.isDirectory()) {

            String path = file.getAbsolutePath();

            for (String ignore : IGNORES) {

                if (path.endsWith(ignore)) {

                    result = false;

                    break;
                }
            }
        }

        return result;
    }

    /**
     * Method description
     *
     *
     * @param dir
     * @param filename
     *
     * @return
     */
    @Override
    public boolean accept(File dir, String filename) {
        return accept(dir);
    }
}
